<template>

	<v-card>
        <v-card-title>
			OTP Verification Form
		</v-card-title>

        <v-card-text>

			<v-form
				ref="form"
				v-model="valid"
				lazy-validation>

				<v-text-field
					v-model="otp"
					:counter="6"
					:rules="otpRules"
					label="OTP"
					required>
				</v-text-field>
				<v-btn
					:disabled="!valid"
					color="success"
					class="mr-4"
					@click="validate">
					Verifikasi OTP
				</v-btn>

				<v-btn
					color="error"
					class="mr-4"
					@click="reset">
					Reset
				</v-btn>

				<alert/>

			</v-form>

        </v-card-text>
        
    </v-card>
  	
</template>

<script>
import alert from '../../components/Alert.vue'
import {mapActions} from 'vuex' 

export default {

	components:{
		alert
	},

	data:function(){
		return{
			valid: true,
			otp: '',
			otpRules: [
				v => !!v || 'Otp is required',				
				v => (v && v.length == 6) || 'OTP must be 6 numeric',
			],  		
		}
	},methods:{
		async submit(){
			try {
				 let response = await axios.post('/api/auth/verification', this.verify())
				 
				 if(response.status == 200){

					let {response_message, response_code} = response.data
					
					if(response_code=="00"){
						this.show({
							title:'success',
							message: response_message,							
						})
						this.$refs.form.reset()
					}else{
						this.show({
							title:'error',
							message: response_message,							
						})
					}

				 }
			} catch (e) {

				console.log(e.response);

				let {message, errors} = e.response.data
				
				console.log('Error is comming');
				console.log(errors);
				
				this.show({
							title:'error',
							message: response_message,
							theErrors:errors							
						})

			}
		},
		validate:function () {
			let isSuccessfullyValidated = this.$refs.form.validate()

			if(isSuccessfullyValidated){
				console.log(`the input parameter are: ${this.otp}`)
				this.submit()
			}else{
				console.log(`the problematic input parameter is : ${this.otp}`)

				this.message = 'Your input is not valid!'
				this.snackbar = true
				this.color = 'red'
			}
			
		},
		reset:function () {
			this.$refs.form.reset()
			this.$refs.form.resetValidation()
		},
		verify:function(){
			return{
				otp:this.otp				
			}
		},
		...mapActions({
			show:'alert/show'
		})				

	},mounted: function(){
		console.log('Verification Screen Mounted')
	}
}
</script>

<style>

</style>